using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace Mod
{
    public class CategoryBuilder : MonoBehaviour
    {

        private GameObject Ruka;

        private GameObject RukaGlow;

        public Boolean Nullified = false; 

        public void Awake()
        {
            Ruka = gameObject;

            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localScale = gameObject.transform.parent.localScale;

            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();

            RukaSprite.sprite = ModAPI.LoadSprite("th.png");
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(1f, 2f, 3f, 1f);
            RukaSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = Ruka.GetComponent<Rigidbody2D>();
            if (Nullified == false)
            {
                if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= -100000f & other.gameObject.GetComponent<Awake7>() == null)
                {
                    other.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 5f;
                    other.gameObject.GetComponent<LimbBehaviour>().Frozen = true;
                    other.gameObject.GetOrAddComponent<SpriteRenderer>().color = new Color(1.5f, 2f, 3.5f, 2f);
                    other.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Wood");
                }
            }



        }

        public void FixedUpdate()
        {
            if(Nullified == false)
            {
                if (Ruka.GetComponent<Rigidbody2D>().velocity.magnitude >= -100000f)
                {
                    RukaGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 2f, 3f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
                }
                else
                {
                    RukaGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 2f, 3f, 1f);
                }
            }

        }
    }
}