﻿using System;
using UnityEngine;

namespace Mod
{
    public class EMP : MonoBehaviour
    {
        private Vector2 barrelPosition = new Vector2(0.865f, 0.082f);
        private Vector2 barrelDirection = new Vector2(1f, 0f);
        private LayerMask layers;
        private LayerMask bounds;
        RaycastHit2D ray;
        AudioSource audio;
        public float power = 3000f;

        LineRenderer line;
        public void Awake()
        {
            layers = LayerMask.GetMask("Objects", "CollidingDebris", "Bounds");
            bounds = LayerMask.GetMask("Bounds");
            line = gameObject.AddComponent<LineRenderer>();
            line.material = ModAPI.FindMaterial("VeryBright");
            line.numCapVertices = 2;
            line.startColor = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 0.25f);
            line.endColor = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 0.25f);
            line.widthMultiplier = 0.26f;
            line.rendererPriority = 5;
            audio = gameObject.AddComponent<AudioSource>();
            audio.outputAudioMixerGroup = Global.main.SoundEffects;
            audio.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
            audio.clip = Cyborg.Hungry.PickRandom();
            audio.loop = true;
            audio.Play();
        }

        public void Shoot()
        {
            line.startColor = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 0.25f);
            line.endColor = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 0.25f);
            line.widthMultiplier = 0.26f;

            if (ray.collider.gameObject.layer == 9)
            {
                ExplosionCreator.CreatePulseExplosion(ray.point, 1f, 1, false);
                ray.transform.SendMessage("EMPHit", SendMessageOptions.DontRequireReceiver);
                ray.transform.SendMessage("Break", SendMessageOptions.DontRequireReceiver);
                ray.transform.BroadcastMessage("Crush", SendMessageOptions.DontRequireReceiver);
                ray.transform.BroadcastMessage("Crush", SendMessageOptions.DontRequireReceiver);
                ray.transform.BroadcastMessage("Crush", SendMessageOptions.DontRequireReceiver);
                ray.transform.BroadcastMessage("Crush", SendMessageOptions.DontRequireReceiver);
                ray.transform.SendMessage("Break", SendMessageOptions.DontRequireReceiver);
                float mass = 0f;
                ModAPI.CreateParticleEffect("FuseBlown", new Vector2(ray.transform.position.x, ray.transform.position.y + -0.5f));
                ModAPI.CreateParticleEffect("Spark", new Vector2(ray.transform.position.x, ray.transform.position.y + -0.5f));
                ModAPI.CreateParticleEffect("BigZap", new Vector2(ray.transform.position.x, ray.transform.position.y + -0.5f));
                ModAPI.CreateParticleEffect("Flash", new Vector2(ray.transform.position.x, ray.transform.position.y + -0.5f));
                ModAPI.CreateParticleEffect("FuseBlown", new Vector2(ray.transform.position.x, ray.transform.position.y + -0.5f));

                for (int i = 0; i < ray.collider.transform.root.GetComponentsInChildren<Rigidbody2D>().Length; i++)
                {
                    mass += ray.collider.transform.root.GetComponentsInChildren<Rigidbody2D>()[i].mass;
                }
               
                ray.collider.GetComponent<Rigidbody2D>().AddForceAtPosition((((BarrelPosition - ray.point).normalized * (power * mass)) * Time.deltaTime) * 0f, ray.point);
            }

        }

        void Update()
        {
            ray = Physics2D.Raycast(BarrelPosition, BarrelDirection, Mathf.Infinity);
            line.SetPosition(0, BarrelPosition);
            line.SetPosition(1, ray.point);
            line.startColor = Color.Lerp(line.startColor, Color.clear, Time.deltaTime);
            line.endColor = Color.Lerp(line.endColor, Color.clear, Time.deltaTime);
            line.widthMultiplier = Mathf.MoveTowards(line.widthMultiplier, 0f, Time.deltaTime);
            audio.volume = line.startWidth * 50f;
        }

        void UseContinuous()
        {
            Shoot();
            CameraShakeBehaviour.main.Shake(20, transform.position);
        }

        public  Vector2 BarrelPosition { get { return transform.TransformPoint(barrelPosition); } }
        public Vector2 BarrelDirection { get { return transform.TransformDirection(barrelDirection) * transform.localScale.x; } }
    }
}
