﻿using System;
using UnityEngine;

namespace Mod
{
    public class EMP2 : MonoBehaviour
    {
        private Vector2 barrelPosition = new Vector2(0.875f, 0.082f);
        private Vector2 barrelDirection = new Vector2(1f, 0f);

        private LayerMask layers;
        private LayerMask bounds;

        RaycastHit2D ray;
        AudioSource audio;
        public float power = 3000f;

        LineRenderer line;
        public void Awake()
        {
            layers = LayerMask.GetMask("Objects", "CollidingDebris", "Bounds");
            bounds = LayerMask.GetMask("Bounds");

            line = gameObject.AddComponent<LineRenderer>();
            line.material = ModAPI.FindMaterial("VeryBright");
            line.numCapVertices = 2;
            line.startColor = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 2f);
            line.endColor = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 2f);
            line.startWidth = 0.12f;
            line.endWidth = 0.12f;
            line.rendererPriority = 5;
            line.sortingLayerName = "Top";
            audio = gameObject.AddComponent<AudioSource>();
            audio.outputAudioMixerGroup = Global.main.SoundEffects;
            audio.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
            audio.clip = Cyborg.Hungry.PickRandom();
            audio.loop = true;
        }

        public void Shoot()
        {
            line.startColor = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 2f);
            line.endColor = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 2f);
            line.startWidth = 0.12f;
            line.endWidth = 0.12f;

            if (ray.collider.gameObject.layer == 9)
            {
                float mass = 0f;
                ModAPI.CreateParticleEffect("Flash", new Vector2(ray.transform.position.x, ray.transform.position.y + -0.5f));

                for (int i = 0; i < ray.collider.transform.root.GetComponentsInChildren<Rigidbody2D>().Length; i++)
                {
                    mass += ray.collider.transform.root.GetComponentsInChildren<Rigidbody2D>()[i].mass;
                }
               
                ray.collider.GetComponent<Rigidbody2D>().AddForceAtPosition((((BarrelPosition - ray.point).normalized * (power * mass)) * Time.deltaTime) * 0f, ray.point);
            }

        }

        void Update()
        {
            ray = Physics2D.Raycast(BarrelPosition, BarrelDirection, Mathf.Infinity);
            line.SetPosition(0, BarrelPosition);
            line.SetPosition(1, ray.point);
            line.startWidth = Mathf.MoveTowards(line.startWidth, 0f, Time.deltaTime);
            line.endWidth = Mathf.MoveTowards(line.endWidth, 0f, Time.deltaTime);
        }

        void UseContinuous()
        {
            Shoot();
        }

        public  Vector2 BarrelPosition { get { return transform.TransformPoint(barrelPosition); } }
        public Vector2 BarrelDirection { get { return transform.TransformDirection(barrelDirection) * transform.localScale.x; } }
    }
}
