﻿using UnityEngine;
using System;
using System.Collections;

namespace Mod
{
    public class EMP8 : MonoBehaviour
    {

        private GameObject hand;

        private GameObject handGlow;

        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];

        public void Awake()
        {
            hand = gameObject;

            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(1f, 1f, 1f, 0.01f);
            handSprite.sortingLayerName = "Top";
            handGlow.FixColliders();
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 10;
                other.transform.BroadcastMessage("Crush", SendMessageOptions.DontRequireReceiver);
                other.transform.BroadcastMessage("Slice", SendMessageOptions.DontRequireReceiver);
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 10;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 1f, 0.01f);
            }
        }
    }
}