﻿using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod : MonoBehaviour
    {	
        public const float PixelSize = Global.MetricMultiplier / 35f;
        public static void Main()
        {
            Cyborg.Initialise();  
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
        NameOverride = "<color=#ea00ff>CTTC- Dubstep Gun", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "More Like Earrape Gun", //new item description
        CategoryOverride = ModAPI.FindCategory("Melee"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("RayGun.png");
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
              {
              ModAPI.Notify("Music: Max Brhon-Humanity AND Phantom Sage & Detrace-PANIC (Anti-Copyright)");
              });
            Instance.GetComponent<DamagableMachineryBehaviour>();
            var childObject = new GameObject();
            childObject.transform.SetParent(Instance.transform);
            childObject.transform.localPosition = new Vector3(0, 0f);
            childObject.transform.localScale = new Vector3(1f, 1f);
            var childSprite = childObject.AddComponent<SpriteRenderer>();
            childSprite.sprite = ModAPI.LoadSprite("RayGunLight.png");
            childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            childSprite.sortingLayerName = "Top";
            Instance.GetOrAddComponent<EMP>();
            Instance.FixColliders();
                     }
                  }
               );
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
        NameOverride = "*&&&&*", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Secret", //new item description
        CategoryOverride = ModAPI.FindCategory(""), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BeamLine.png");
            Instance.GetComponent<DamagableMachineryBehaviour>();
            var childObject = new GameObject();
            childObject.transform.SetParent(Instance.transform);
            childObject.transform.localPosition = new Vector3(0, 0f);
            childObject.transform.localScale = new Vector3(1f, 1f);
            var childSprite = childObject.AddComponent<SpriteRenderer>();
            childSprite.color = new Color(1f, 1f, 1f, 2f);
            childSprite.sprite = ModAPI.LoadSprite("BeamLine.png");
            childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            childSprite.sortingLayerName = "Top";
            Instance.FixColliders();
                     }
                  }
               );
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
        NameOverride = "<color=#ea00ff>CTTC- Dubstep Shotgun", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Shoots 3 Dubstep Beam At Once", //new item description
        CategoryOverride = ModAPI.FindCategory("Melee"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb6.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            AudioSource Audio = Instance.AddComponent<AudioSource>();
            Audio.maxDistance = 2;
            Audio.loop = false;
            Audio.clip = ModAPI.LoadSound("tel2.wav");
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
              {
            Audio.Play(); 
              });
            Instance.GetOrAddComponent<EMP11>();
            Instance.GetOrAddComponent<EMP12>();
            Instance.GetOrAddComponent<ShieldBehaviour>();
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("RayS.png");
            var childObject = new GameObject();
            childObject.transform.SetParent(Instance.transform);
            childObject.transform.localPosition = new Vector3(0, 0f);
            childObject.transform.localScale = new Vector3(1f, 1f);
            var childSprite = childObject.AddComponent<SpriteRenderer>();
            childSprite.sprite = ModAPI.LoadSprite("RaySLight.png");
            childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            childSprite.sortingLayerName = "Top";
            Instance.FixColliders();
                     }
                  }
               );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "<color=#ea00ff>CTTC- Dubstep Robot",
                    DescriptionOverride = "Activate his speaker head to create a strong shockwave",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb4.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("DubSkin.png");
                        var flesh = ModAPI.LoadTexture("DubFlesh.png");
                        var bone = ModAPI.LoadTexture("DubFlesh.png");

                        var person = Instance.GetComponent<PersonBehaviour>();

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var f1 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var f2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var head = Instance.transform.Find("Head");
                   AudioSource Audio = Instance.AddComponent<AudioSource>();
                   Audio.maxDistance = 100;
                   Audio.loop = false;
                   Audio.clip = ModAPI.LoadSound("tel3.wav");
                   UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
                   useEventTrigger.Event = new UnityEvent();
                   useEventTrigger.Event.AddListener(delegate ()
                    {
                     Audio.Play(); 
                    });

                        var eye = ModAPI.CreateLight(upper, Color.cyan, 2.5f, 2.5f);
                        eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);

                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        head.gameObject.AddComponent<EMP6>();


                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength += 4f;
                            body.Health += 1000000000000;
                            body.InitialHealth += 1000000000000;
                            body.SkinMaterialHandler.ClearAllDamage();
                            body.PhysicalBehaviour.ChargeBurns = false;
			    body.PhysicalBehaviour.BurnProgress = 0f;
                            body.ShotDamageMultiplier = 0f;
                            body.Vitality *= 4.5f;
			    body.ImmuneToDamage = true;
			    body.CirculationBehaviour.ImmuneToDamage = true;
			    body.PhysicalBehaviour.Disintegratable = false;
                            body.gameObject.GetComponent<Awake>();
                            body.ImpactPainMultiplier = 0f;
                            body.Numbness *= -100000f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 55f;
                            body.RegenerationSpeed += 1000000000000;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties.ShallowClone().Flammability = 0f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = -2000000000000f;
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                            body.CirculationBehaviour.BloodFlow *= 0f;
                       }
        }
    }
);
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
        NameOverride = "<color=#ea00ff>CTTC- Dubstep Pistol", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Its A More Discret Dubstep Gun", //new item description
        CategoryOverride = ModAPI.FindCategory("Melee"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb5.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            AudioSource Audio = Instance.AddComponent<AudioSource>();
            Audio.maxDistance = 100;
            Audio.loop = false;
            Audio.clip = ModAPI.LoadSound("tel3.wav");
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("RayGun.png");
            UseEventTrigger useEventTrigger = Instance.AddComponent<UseEventTrigger>();
            useEventTrigger.Event = new UnityEvent();
            useEventTrigger.Event.AddListener(delegate ()
              {
            Audio.Play(); 
              });
            Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[] { new Vector3(-0.08f, 0f) };
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("RayPis.png");
            Instance.GetComponent<DamagableMachineryBehaviour>();
            var childObject = new GameObject();
            childObject.transform.SetParent(Instance.transform);
            childObject.transform.localPosition = new Vector3(0, 0f);
            childObject.transform.localScale = new Vector3(1f, 1f);
            var childSprite = childObject.AddComponent<SpriteRenderer>();
            childSprite.sprite = ModAPI.LoadSprite("RayPisLight.png");
            childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            childSprite.sortingLayerName = "Top";
            Instance.GetOrAddComponent<EMP5>();
            Instance.FixColliders();
                     }
                  }
               );

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("EMP Generator"), //item to derive from
        NameOverride = "<color=#ea00ff>CTTC- Dubstep Sword", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Activate it to use its EMP Dubstep Shockwave + sliced things will become weightless", //new item description
        CategoryOverride = ModAPI.FindCategory("Melee"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb3.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {

            var line = Instance.AddComponent<TrailRenderer>();
            line.startWidth = 0.45f;
            line.material = ModAPI.FindMaterial("VeryBright").ShallowClone();
            line.material = new Material(Shader.Find("Unlit/EnergySword"));
            line.material.SetColor("_GlowColour", new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 2000));
            line.time = 0.16f;
            line.endColor = new Color(1f, 1f, 1f, 1f);
            line.startColor = new Color(1f, 1f, 1f, 1f);
            line.sortingOrder = -1;
            UnityEngine.Object.Destroy(Instance.GetComponent<DamagableMachineryBehaviour>());
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("DubSword.png");
            Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("tel2.wav")};
            Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[] { new Vector3(0f, -0.4f) };
            var chevolek = Instance.GetComponent<PhysicalBehaviour>().Properties.ShallowClone();
            chevolek.SharpAxes = new SharpAxis[] { new SharpAxis(Vector2.up, 4f, -1.5f, true, true) };
            var childObject = new GameObject();
            childObject.transform.SetParent(Instance.transform);
            childObject.transform.localPosition = new Vector3(0, 0f);
            childObject.transform.localScale = new Vector3(1f, 1f);
            var childSprite = childObject.AddComponent<SpriteRenderer>();
            childSprite.sprite = ModAPI.LoadSprite("DubSwordLight.png");
            childSprite.color = new Color(1f, 1f, 1f, 0.06f);
            childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            childSprite.sortingLayerName = "Top";
            Instance.GetOrAddComponent<EMP7>();
            Instance.FixColliders();
                     }
                  }
               );
	ModAPI.Register(
	new Modification()
	{
         OriginalItem = ModAPI.FindSpawnable("Crossbow"),
         NameOverride = "<color=#ea00ff>CTTC- Dubstep RPG",
         DescriptionOverride = "Shoots A Unstable Dubstep Laser That Will ?Strongly? Blow Up On Collision",
         CategoryOverride = ModAPI.FindCategory("Melee"),
         ThumbnailOverride = ModAPI.LoadSprite("thumb2.png"),
         AfterSpawn = (Instance) =>
	    {
            var childObject = new GameObject();
            childObject.transform.SetParent(Instance.transform);
            childObject.transform.localPosition = new Vector3(0, 0f);
            childObject.transform.localScale = new Vector3(1f, 1f);
            var childSprite = childObject.AddComponent<SpriteRenderer>();
            childSprite.sprite = ModAPI.LoadSprite("RayPGLight.png");
            childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            childSprite.sortingLayerName = "Top";
            Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("ÉÈÉÈ");
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("RayPG.png");
            Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("tel4.wav");
            Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = true;
            Instance.GetComponent<ProjectileLauncherBehaviour>().ScreenShake = 20f;
            Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 15f;
            Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Brick"), //item to derive from
        NameOverride = "ÉÈÉÈ", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "", //new item description
        CategoryOverride = ModAPI.FindCategory(""), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thumb.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            Instance.GetComponent<Rigidbody2D>().freezeRotation = true;
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("th.png");
            AudioSource Audio2 = Instance.AddComponent<AudioSource>();
            Audio2.maxDistance = 50;
            Audio2.loop = false;
            Audio2.clip = ModAPI.LoadSound("dubgun3.wav");
            Audio2.Play(); 
            Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0.3f;
            Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("tel2.wav")};
            Instance.GetOrAddComponent<EMP10>();
            Instance.FixColliders();
                     }
                  }
               );
            }
        }
    }